Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoGetMatrixAction Class Reference
[Actions]

`#include <Inventor/actions/SoGetMatrixAction.h>`

Inheritance diagram for SoGetMatrixAction:

List of all members.

## Detailed Description

The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph.

This action makes it easy to calculate and convert to and from the global coordinate system of your scene and local coordinates of parts in a hierarchical model.

As opposed to most other action types, the SoGetMatrixAction does not traverse children of the node it is applied to -- just the node itself. When applied to paths, it stops at the last node and does not continue further with the children of the tail node.

Typical usage when querying for world space position, orientation and/or scaling would be as follows:

      // First get hold of an SoPath through the scenegraph down to the
      // node ("mynode") you want to query about it's current world space
      // transformation(s).

      SoSearchAction * searchaction = new SoSearchAction;
      searchaction->setNode(mynode);
      searchaction->apply(myscenegraphroot);

      SoPath * path = searchaction->getPath();
      assert(path != NULL);

      // Then apply the SoGetMatrixAction to get the full transformation
      // matrix from world space.

      const SbViewportRegion vpr = myviewer->getViewportRegion();
      SoGetMatrixAction * getmatrixaction = new SoGetMatrixAction(vpr);
      getmatrixaction->apply(path);

      SbMatrix transformation = getmatrixaction->getMatrix();

      // And if you want to access the individual transformation
      // components of the matrix:

      SbVec3f translation;
      SbRotation rotation;
      SbVec3f scalevector;
      SbRotation scaleorientation;

      transformation.getTransform(translation, rotation, scalevector, scaleorientation);

## Public Member Functions
| SoGetMatrixAction (const SbViewportRegion &region)
virtual | ~SoGetMatrixAction ()
void | setViewportRegion (const SbViewportRegion &region)
const SbViewportRegion & | getViewportRegion (void) const
SbMatrix & | getMatrix (void)
SbMatrix & | getInverse (void)
SbMatrix & | getTextureMatrix (void)
SbMatrix & | getTextureInverse (void)
## Static Public Member Functions
void | initClass (void)
## Protected Member Functions
virtual void | beginTraversal (SoNode *node)

## Constructor & Destructor Documentation

SoGetMatrixAction::SoGetMatrixAction | ( | const SbViewportRegion & | region | ) |

| Constructor. The region viewport specification is not used by this action, and is passed along in case it is needed by any nodes.

SoGetMatrixAction::~SoGetMatrixAction | ( |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

void SoGetMatrixAction::initClass | ( | void |  | ) | `[static]`

| Initializes the run-time type system for this class, and sets up the enabled elements and action method list. Reimplemented from SoAction.

void SoGetMatrixAction::setViewportRegion | ( | const SbViewportRegion & | region | ) |

| Set the viewport region. See also: SoGetMatrixAction::SoGetMatrixAction()

const SbViewportRegion & SoGetMatrixAction::getViewportRegion | ( | void |  | ) | const

| Returns the viewport region for the action instance.

SbMatrix & SoGetMatrixAction::getMatrix | ( | void |  | ) |

| Returns the accumulated transformation matrix. Note: don't modify the returned matrix. This should only be done if you are implementing your own transformation type node extensions. This advice is also valid for the other matrix access methods documented below.

SbMatrix & SoGetMatrixAction::getInverse | ( | void |  | ) |

| Returns the inverse of the accumulated transformation matrix.

SbMatrix & SoGetMatrixAction::getTextureMatrix | ( | void |  | ) |

| Returns the accumulated texture matrix.

SbMatrix & SoGetMatrixAction::getTextureInverse | ( | void |  | ) |

| Returns the inverse of the accumulated texture matrix.

void SoGetMatrixAction::beginTraversal | ( | SoNode * | node | ) | `[protected, virtual]`

| This virtual method is called from SoAction::apply(), and is the entry point for the actual scenegraph traversal. It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction. Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scenegraph traversal. Reimplemented from SoAction.

The documentation for this class was generated from the following files:

- SoGetMatrixAction.h
- SoGetMatrixAction.cpp